<?php

namespace Drupal\ief_table_view\Plugin\views\display;

use Drupal\ief_table_view\InlineEntityForm\InlineEntityFormTableProviderInterface;
use Drupal\views\Plugin\views\display\DisplayPluginBase;

/**
 * Views display plugin for IEF table.
 *
 * @ViewsDisplay(
 *   id = "ief_table",
 *   title = @Translation("Inline Entity Form Table"),
 *   admin = @Translation("Inline Entity Form Table Source"),
 *   help = @Translation("Exposed the view for use as a table within inline entity form widgets."),
 *   theme = "views_view",
 *   register_theme = FALSE,
 *   uses_menu_links = FALSE,
 *   ief_table_display = TRUE
 * )
 */
class InlineEntityFormTableDisplay extends DisplayPluginBase implements InlineEntityFormTableProviderInterface {

  /**
   * {@inheritdoc}
   */
  protected $usesAJAX = FALSE;

  /**
   * {@inheritdoc}
   */
  protected $usesPager = FALSE;

  /**
   * {@inheritdoc}
   */
  protected $usesAttachments = FALSE;

  /**
   * {@inheritdoc}
   */
  public function usesExposed() {
    return FALSE;
  }

  /**
   * {@inheritdoc}
   */
  public function getType() {
    return 'ief_table';
  }

  /**
   * {@inheritdoc}
   */
  public function getInlineEntityFormTableColumns() {
    // Pass this off to the style plugin if possible.
    $style = $this->view->style_plugin;
    if (!$style instanceof InlineEntityFormTableProviderInterface) {
      return [];
    }
    return $style->getInlineEntityFormTableColumns();
  }

}
